var downloadInterval = null;
var defaultScrollInterval = 85;
var scoresTop = 0;
var scrolling = true;
var xmlData = null;
var automation = {download:null, scroll:null}
var leagues = [
	{name:"MLB", url:"http://msn.foxsports.com/nugget/9240_49"}
];

var teams = [
	{name:"Baltimore Orioles", shortname:"Bal", league:"American", division:"East"},
	{name:"Boston Red Sox", shortname:"Bos", league:"American", division:"East"},
	{name:"Toronto Blue Jays", shortname:"Tor", league:"American", division:"East"},
	{name:"New York Yankees", shortname:"NYY", league:"American", division:"East"},
	{name:"Tampa Bay Devil Rays", shortname:"TB", league:"American", division:"East"},
	{name:"Chicago White Sox", shortname:"CWS", league:"American", division:"Central"},
	{name:"Minnesota Twins", shortname:"Min", league:"American", division:"Central"},
	{name:"Detroit Tigers", shortname:"Det", league:"American", division:"Central"},
	{name:"Cleveland Indians", shortname:"Cle", league:"American", division:"Central"},
	{name:"Kansas City Royals", shortname:"KC", league:"American", division:"Central"},
	{name:"Los Angeles Angels", shortname:"LAA", league:"American", division:"East"},
	{name:"Texas Rangers", shortname:"Tex", league:"American", division:"East"},
	{name:"Oakland Athletics", shortname:"Oak", league:"American", division:"East"},
	{name:"Seattle Mariners", shortname:"Sea", league:"American", division:"East"},
	{name:"Atlanta Braves", shortname:"Atl", league:"National", division:"East"},
	{name:"Florida Marlins", shortname:"Fla", league:"National", division:"East"},
	{name:"Washington Nationals", shortname:"Was", league:"National", division:"East"},
	{name:"New York Mets", shortname:"NYM", league:"National", division:"East"},
	{name:"Philadelphia Phillies", shortname:"Phi", league:"National", division:"East"},
	{name:"St. Louis Cardinals", shortname:"StL", league:"National", division:"Central"},
	{name:"Milwaukee Brewers", shortname:"Mil", league:"National", division:"Central"},
	{name:"Chicago Cubs", shortname:"ChC", league:"National", division:"Central"},
	{name:"Pittsburgh Pirates", shortname:"Pit", league:"National", division:"Central"},
	{name:"Cincinnati Reds", shortname:"Cin", league:"National", division:"Central"},
	{name:"Houston Astros", shortname:"Hou", league:"National", division:"Central"},
	{name:"Los Angeles Dodgers", shortname:"LAD", league:"National", division:"East"},
	{name:"Arizona Diamondbacks", shortname:"Ari", league:"National", division:"East"},
	{name:"San Diego Padres", shortname:"SD", league:"National", division:"East"},
	{name:"San Francisco Giants", shortname:"SF", league:"National", division:"East"},
	{name:"Colorado Rockies", shortname:"Col", league:"National", division:"East"}
];

function setup() {
	if(window.widget) {
		widget.onhide = onhide;
		widget.onremove = onremove;
	}
	
	document.getElementById("scores").style.top = 0;
	createGenericButton(document.getElementById("doneButton"), "Done", hidePrefs, 67);
	loadLeagueSelect();
	onshow();
}


function loadLeagueSelect() {
	for (var i = 0; i < leagues.length; i++)
		document.getElementById("leagueselect").appendChild(new Option(leagues[i].name, leagues[i].url));
}


function loadGameSelect() {
	var games = xmlData.getElementsByTagName("game");
	var select = document.getElementById("gameselect");

	var gameId = window.widget && widget.preferenceForKey(widget.identifier + "gameId") && !downloadInterval ? widget.preferenceForKey(widget.identifier + "gameId") : select.options[select.selectedIndex].value;
	while(select.options.length > teams.length + 1) 
		select.remove(1);

	for(var i = 0; i < teams.length; i++) {
		if(select.options.length < teams.length + 1)
			select.appendChild(new Option(teams[i].name, teams[i].shortname));
		if(teams[i].shortname == gameId) 
			select.selectedIndex = i + 1;
	}

	for(var i = 0; i < games.length; i++) {
		select.add(new Option(games[i].awayTeam + " @ " + games[i].homeTeam + " - " + games[i].gameStatus, games[i].gameId), select.options[i + 1]);
		if(games[i].gameId == gameId) 
			select.selectedIndex = i + 1;
	}
	
	if(window.widget) widget.setPreferenceForKey(select.options[select.selectedIndex].value, widget.identifier + "gameId");
}


function onshow() {
	clearInterval(automation.download);
	clearInterval(automation.scroll);

	var select = document.getElementById("leagueselect"); 
 	loadXML(select.options[select.selectedIndex].value, "loadGameSelect()", 1);

	select = document.getElementById("refreshselect");
	downloadInterval = !downloadInterval && window.widget && widget.preferenceForKey(widget.identifier + "downloadInterval") ? 
		widget.preferenceForKey(widget.identifier + "downloadInterval") : select.options[select.selectedIndex].value;
	if(window.widget)
		widget.setPreferenceForKey(downloadInterval, widget.identifier + "downloadInterval");
	automation.download = setInterval("onshow()", downloadInterval * 1000);
	select.selectedIndex = downloadInterval / 30 - 1;
		
	select = document.getElementById("gameselect");
	
	loadLeague();
	gameId = select.options[select.selectedIndex].value;
	if(gameId == 'all' && scrolling) 
		automation.scroll = setInterval("autoScroll()", defaultScrollInterval);
	else
		document.getElementById("scores").style.top = "0";
}


function onhide() {
	widget.onshow = onshow;
	clearInterval(automation.scroll);
	clearInterval(automation.download);
}

function onremove() {
	widget.setPreferenceForKey(null, widget.identifier + "gameId");
	widget.setPreferenceForKey(null, widget.identifier + "downloadInterval");
}


function loadLeague() {
	var select = document.getElementById("gameselect");
	var iterations = 1;
	if(select.options[select.selectedIndex].value == "all")
		iterations++;
		
	select = document.getElementById("leagueselect");
	loadXML (select.options[select.selectedIndex].value, "load" + select.options[select.selectedIndex].text + "Scores()", iterations);	
}


function clearScores() {
	var select = document.getElementById ("scores");
	while(select.childNodes.length)
		select.removeChild(select.firstChild);
}


function loadXML(xmlUrl, callback, iterations)	{
	var xmlhttp = new XMLHttpRequest();

	while(xmlhttp.status != 200) {
		xmlhttp.open("GET", xmlUrl, false);
		xmlhttp.send(null);
	}

	xmlData = xmlhttp.responseXML;
	clearScores();
	for(var i = 0; i < iterations; i++)
		eval(callback);
}


function loadMLBScores() {
	document.getElementById("title").innerText = xmlData.getElementsByTagName("games")[0].label;
	var games = xmlData.getElementsByTagName("game");
	var scoreset = document.createElement("div");
	var gameSelect = document.getElementById("gameselect");
	var gameId = gameSelect.options[gameSelect.selectedIndex].value;
	
	for(var i = 0; i < games.length; i++) {
		if (gameId != "all" && games[i].gameId != gameId && games[i].homeTeam != gameId && games[i].awayTeam != gameId)
			continue;
		var table = document.createElement("table");
		for(var j = 0; j < 3; j++) 
			table.insertRow();
			
		table.setAttribute("onclick", "openUrl('http://msn.foxsports.com" + xmlData.getElementsByTagName("games")[0].link + games[i].gameId + "')");
		table.rows[0].appendChild(document.createElement("td"));
		table.rows[0].lastChild.className = "awayteam";
		table.rows[0].lastChild.innerHTML = games[i].gameStatus.substr(0,3) == "TOP" ? 
			games[i].awayTeam + "<span class='atbatindicator'>&#8860;</span>" : games[i].awayTeam;
		if(parseInt(games[i].awayScore) > parseInt(games[i].homeScore))
			table.rows[0].lastChild.innerHTML = "<span class='winner'>" + table.rows[0].lastChild.innerHTML + "</span>";
		
		table.rows[0].appendChild(document.createElement("td"));
		table.rows[0].lastChild.className = "awayscore";
		table.rows[0].lastChild.innerHTML = games[i].awayScore;
		
		table.rows[0].appendChild(document.createElement("td"));
		table.rows[0].lastChild.className = "balls" + games[i].balls;
		table.rows[0].lastChild.innerHTML = "B";
		table.rows[0].lastChild.appendChild(document.createElement("span"));
		table.rows[0].lastChild.lastChild.className = "glyph";
		
		table.rows[0].appendChild(document.createElement("td"));
		table.rows[0].lastChild.setAttribute("rowspan", "3");
		table.rows[0].lastChild.className = "bases" + games[i].mob1 + games[i].mob2 + games[i].mob3;

		table.rows[1].appendChild(document.createElement("td"));
		table.rows[1].lastChild.className = "hometeam";
		table.rows[1].lastChild.innerHTML = games[i].gameStatus.substr(0,3) == "BOT" ? 
			games[i].homeTeam + "<span class='atbatindicator'>&#8860;</span>" : games[i].homeTeam;
		if(parseInt(games[i].homeScore) > parseInt(games[i].awayScore))
			table.rows[1].lastChild.innerHTML = "<span class='winner'>" + table.rows[1].lastChild.innerHTML + "</span>";
		
		table.rows[1].appendChild(document.createElement("td"));
		table.rows[1].lastChild.className = "homescore";
		table.rows[1].lastChild.innerHTML = games[i].homeScore;
		
		table.rows[1].appendChild(document.createElement("td"));
		table.rows[1].lastChild.className = "strikes" + games[i].strikes;
		table.rows[1].lastChild.innerHTML = "S";
		table.rows[1].lastChild.appendChild(document.createElement("span"));
		table.rows[1].lastChild.lastChild.className = "glyph";
		
		table.rows[2].appendChild(document.createElement("td"));
		table.rows[2].lastChild.className = "gamestatus";
		table.rows[2].lastChild.setAttribute("colspan", "2");
		table.rows[2].lastChild.innerHTML = games[i].gameStatus;
		
		table.rows[2].appendChild(document.createElement("td"));
		table.rows[2].lastChild.className = "outs" + games[i].outs;
		table.rows[2].lastChild.innerHTML = "O";
		table.rows[2].lastChild.appendChild(document.createElement("span"));
		table.rows[2].lastChild.lastChild.className = "glyph";
					
		scoreset.appendChild(table);
	}
	if(scoreset.childNodes.length == 0) {
		document.body.className = "mlbsingle";
		document.getElementById("scores").appendChild(document.createElement("p"));
		document.getElementById("scores").lastChild.innerText = "The " + gameSelect.options[gameSelect.selectedIndex].text + " have no games scheduled today.";
	} else if(scoreset.childNodes.length == 1) 
		document.body.className = "mlbsingle";
	else if (scoreset.childNodes.length == 2)
		document.body.className = "mlbdouble";
	else
		document.body.className = "mlbdefault";

	document.getElementById("scores").appendChild(scoreset);
}

function autoScroll () {
	element = document.getElementById("scores");
	if(element.childNodes.length) {
		if (scoresTop <= -1 * element.childNodes[0].offsetHeight) {
			element.appendChild(element.childNodes[0]);
			scoresTop = -1;
		}  else
			scoresTop--;
	
		element.style.top = scoresTop + "px";
	}
}

function playpause() {
	if(scrolling) {
		scrolling = 0;
		document.getElementById("playpause").style.background = "url(play.png) no-repeat";
		clearInterval(automation.scroll);
	} else {
		scrolling = 1;
		document.getElementById("playpause").style.background = "url(pause.png) no-repeat";
		automation.scroll = setInterval("autoScroll()", defaultScrollInterval);
	}
}


function openUrl(url) {
	if(window.widget) 
		widget.openURL(url);
	else window.location = url;
}
	
function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}


var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event) {
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit (event) {
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate() {
    var T;
    var ease;
    var time = (new Date).getTime();              
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration) {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    } else {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}